commit 6a1358f7ea1111475e9d46c1535656bdfb2a7904
Author: Jan Hubicka <jh@suse.cz>
Date:   Sun Nov 21 00:35:22 2021

    Fix looping flag discovery in ipa-pure-const
    
    The testcase shows situation where there is non-trivial cycle in the callgraph
    involving a noreturn call.  This cycle is important for const function discovery
    but not important for pure.  IPA pure const uses same strongly connected
    components for both propagations which makes it to get suboptimal result
    (does not detect the pure flag). However local pure const gets the situation
    right becaue it processes functions in right order.  This hits rarely
    executed code in propagate_pure_const that merge results with previously
    known state that has long standing bug in it that makes it to throw away
    the looping flag.
    
    Bootstrapped/regtested x86_64-linux.
    
    gcc/ChangeLog:
    
    2021-11-21  Jan Hubicka  <hubicka@ucw.cz>
    
            PR ipa/103052
            * ipa-pure-const.c (propagate_pure_const): Fix merging of loping flag.
    
    gcc/testsuite/ChangeLog:
    
    2021-11-21  Jan Hubicka  <hubicka@ucw.cz>
    
            PR ipa/103052
            * gcc.c-torture/execute/pr103052.c: New test.
    
    (cherry picked from commit a0e99d5bb741d3db74a67d492f47b28217fbf88a)

diff --git a/gcc/testsuite/gcc.c-torture/execute/pr103052.c b/gcc/testsuite/gcc.c-torture/execute/pr103052.c
new file mode 100644
index 00000000000..bef8674a43c
--- /dev/null
+++ b/gcc/testsuite/gcc.c-torture/execute/pr103052.c
@@ -0,0 +1,35 @@
+static void js_error(void);
+static int top;
+static void js_throw(void)
+{
+	__builtin_exit(0);
+}
+
+// LOCATION A -- if js_pop is here, the bug is present
+static void js_pop(void)
+{
+	if (++top > 100)
+		js_error();
+}
+
+static void jsC_error(const char *v)
+{
+	if (v[0] == 0)
+		js_error();
+	js_throw();
+}
+static void checkfutureword(const char *exp)
+{
+	if (!__builtin_strcmp(exp, "const"))
+		jsC_error("boom");
+}
+static void js_error(void) {
+	checkfutureword("foo");
+	checkfutureword("bar");
+	js_pop();
+}
+int main(void)
+{
+	checkfutureword("const");
+	__builtin_abort ();
+}

